zenilib: zenilib/jni/external/freetype2/include/freetype/ftstroke.h File Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Typedefs | Enumerations | Functions
ftstroke.h File Reference
`#include <ft2build.h>`
`#include <FT_OUTLINE_H>`
`#include <FT_GLYPH_H>`

Go to the source code of this file.

## Typedefs

typedef typedefFT_BEGIN_HEADER struct FT_StrokerRec_ * | FT_Stroker
typedef enum FT_Stroker_LineCap_ | FT_Stroker_LineCap
typedef enum FT_Stroker_LineJoin_ | FT_Stroker_LineJoin
typedef enum FT_StrokerBorder_ | FT_StrokerBorder

## Enumerations

enum | FT_Stroker_LineCap_ { FT_STROKER_LINECAP_BUTT = 0, FT_STROKER_LINECAP_ROUND, FT_STROKER_LINECAP_SQUARE }
enum | FT_Stroker_LineJoin_ { FT_STROKER_LINEJOIN_ROUND = 0, FT_STROKER_LINEJOIN_BEVEL = 1, FT_STROKER_LINEJOIN_MITER_VARIABLE = 2, FT_STROKER_LINEJOIN_MITER = FT_STROKER_LINEJOIN_MITER_VARIABLE, FT_STROKER_LINEJOIN_MITER_FIXED = 3 }
enum | FT_StrokerBorder_ { FT_STROKER_BORDER_LEFT = 0, FT_STROKER_BORDER_RIGHT }

## Functions

| FT_Glyph_Stroke (FT_Glyph *pglyph, FT_Stroker stroker, FT_Bool destroy)
| FT_Glyph_StrokeBorder (FT_Glyph *pglyph, FT_Stroker stroker, FT_Bool inside, FT_Bool destroy)
| FT_Outline_GetInsideBorder (FT_Outline *outline)
| FT_Outline_GetOutsideBorder (FT_Outline *outline)
| FT_Stroker_BeginSubPath (FT_Stroker stroker, FT_Vector *to, FT_Bool open)
| FT_Stroker_ConicTo (FT_Stroker stroker, FT_Vector *control, FT_Vector *to)
| FT_Stroker_CubicTo (FT_Stroker stroker, FT_Vector *control1, FT_Vector *control2, FT_Vector *to)
| FT_Stroker_Done (FT_Stroker stroker)
| FT_Stroker_EndSubPath (FT_Stroker stroker)
| FT_Stroker_Export (FT_Stroker stroker, FT_Outline *outline)
| FT_Stroker_ExportBorder (FT_Stroker stroker, FT_StrokerBorder border, FT_Outline *outline)
| FT_Stroker_GetBorderCounts (FT_Stroker stroker, FT_StrokerBorder border, FT_UInt *anum_points, FT_UInt *anum_contours)
| FT_Stroker_GetCounts (FT_Stroker stroker, FT_UInt *anum_points, FT_UInt *anum_contours)
| FT_Stroker_LineTo (FT_Stroker stroker, FT_Vector *to)
| FT_Stroker_New (FT_Library library, FT_Stroker *astroker)
| FT_Stroker_ParseOutline (FT_Stroker stroker, FT_Outline *outline, FT_Bool opened)
| FT_Stroker_Rewind (FT_Stroker stroker)
| FT_Stroker_Set (FT_Stroker stroker, FT_Fixed radius, FT_Stroker_LineCap line_cap, FT_Stroker_LineJoin line_join, FT_Fixed miter_limit)

## Typedef Documentation

typedef typedefFT_BEGIN_HEADER struct FT_StrokerRec_* FT_Stroker

Definition at line 60 of file ftstroke.h.

typedef enum FT_Stroker_LineCap_ FT_Stroker_LineCap

typedef enum FT_Stroker_LineJoin_ FT_Stroker_LineJoin

typedef enum FT_StrokerBorder_ FT_StrokerBorder

## Enumeration Type Documentation

enum FT_Stroker_LineCap_

Enumerator
FT_STROKER_LINECAP_BUTT |
FT_STROKER_LINECAP_ROUND |
FT_STROKER_LINECAP_SQUARE |

Definition at line 142 of file ftstroke.h.

enum FT_Stroker_LineJoin_

Enumerator
FT_STROKER_LINEJOIN_ROUND |
FT_STROKER_LINEJOIN_BEVEL |
FT_STROKER_LINEJOIN_MITER_VARIABLE |
FT_STROKER_LINEJOIN_MITER |
FT_STROKER_LINEJOIN_MITER_FIXED |

Definition at line 109 of file ftstroke.h.

enum FT_StrokerBorder_

Enumerator
FT_STROKER_BORDER_LEFT |
FT_STROKER_BORDER_RIGHT |

Definition at line 176 of file ftstroke.h.

## Function Documentation

FT_Glyph_Stroke | ( | FT_Glyph * | pglyph,
|  | FT_Stroker | stroker,
|  | FT_Bool | destroy
| ) |  |

Definition at line 2258 of file ftstroke.c.

References FT_GlyphRec_::clazz, error, FALSE, FT_Done_Glyph(), FT_Err_Invalid_Argument, FT_Glyph_Copy(), FT_Outline_Done(), FT_OUTLINE_GLYPH_CLASS_GET, FT_Outline_New(), FT_Stroker_Export(), FT_Stroker_GetCounts(), FT_Stroker_ParseOutline(), FT_UNUSED, FT_GlyphRec_::library, library, FT_Outline_::n_contours, FT_Outline_::n_points, NULL, and FT_OutlineGlyphRec_::outline.

FT_Glyph_StrokeBorder | ( | FT_Glyph * | pglyph,
|  | FT_Stroker | stroker,
|  | FT_Bool | inside,
|  | FT_Bool | destroy
| ) |  |

Definition at line 2333 of file ftstroke.c.

References FT_GlyphRec_::clazz, error, FALSE, FT_Done_Glyph(), FT_Err_Invalid_Argument, FT_Glyph_Copy(), FT_Outline_Done(), FT_Outline_GetOutsideBorder(), FT_OUTLINE_GLYPH_CLASS_GET, FT_Outline_New(), FT_STROKER_BORDER_LEFT, FT_STROKER_BORDER_RIGHT, FT_Stroker_ExportBorder(), FT_Stroker_GetBorderCounts(), FT_Stroker_ParseOutline(), FT_UNUSED, FT_GlyphRec_::library, library, FT_Outline_::n_contours, FT_Outline_::n_points, NULL, and FT_OutlineGlyphRec_::outline.

FT_Outline_GetInsideBorder | ( | FT_Outline * | outline | ) |

Definition at line 31 of file ftstroke.c.

References FT_ORIENTATION_TRUETYPE, FT_Outline_Get_Orientation(), FT_STROKER_BORDER_LEFT, and FT_STROKER_BORDER_RIGHT.

FT_Outline_GetOutsideBorder | ( | FT_Outline * | outline | ) |

Definition at line 44 of file ftstroke.c.

References FT_ORIENTATION_TRUETYPE, FT_Outline_Get_Orientation(), FT_STROKER_BORDER_LEFT, and FT_STROKER_BORDER_RIGHT.

Referenced by FT_Glyph_StrokeBorder().

FT_Stroker_BeginSubPath | ( | FT_Stroker | stroker,
|  | FT_Vector * | to,
|  | FT_Bool | open
| ) |  |

Definition at line 1758 of file ftstroke.c.

References FT_BOOL, FT_Err_Ok, FT_STROKER_LINECAP_BUTT, FT_STROKER_LINEJOIN_ROUND, and TRUE.

Referenced by FT_Stroker_ParseOutline().

FT_Stroker_ConicTo | ( | FT_Stroker | stroker,
|  | FT_Vector * | control,
|  | FT_Vector * | to
| ) |  |

Definition at line 1353 of file ftstroke.c.

References error, FALSE, FT_Angle, FT_Angle_Diff(), FT_ANGLE_PI, FT_Atan2(), FT_Bool, ft_conic_is_small_enough(), ft_conic_split(), FT_Cos(), FT_DivFix(), FT_Err_Ok, FT_IS_SMALL, FT_MulFix(), ft_pos_abs(), FT_SIDE_TO_ROTATE, FT_Sin(), FT_SMALL_CONIC_THRESHOLD, ft_stroke_border_conicto(), ft_stroke_border_lineto(), FT_STROKER_LINEJOIN_ROUND, ft_stroker_process_corner(), ft_stroker_subpath_start(), FT_Vector_From_Polar(), FT_Vector_Length(), TRUE, FT_Vector_::x, and FT_Vector_::y.

Referenced by FT_Stroker_ParseOutline().

FT_Stroker_CubicTo | ( | FT_Stroker | stroker,
|  | FT_Vector * | control1,
|  | FT_Vector * | control2,
|  | FT_Vector * | to
| ) |  |

Definition at line 1548 of file ftstroke.c.

References error, FALSE, FT_Angle, FT_Angle_Diff(), ft_angle_mean(), FT_ANGLE_PI, FT_Atan2(), FT_Bool, FT_Cos(), ft_cubic_is_small_enough(), ft_cubic_split(), FT_DivFix(), FT_Err_Ok, FT_IS_SMALL, FT_MulFix(), ft_pos_abs(), FT_SIDE_TO_ROTATE, FT_Sin(), FT_SMALL_CUBIC_THRESHOLD, ft_stroke_border_cubicto(), ft_stroke_border_lineto(), FT_STROKER_LINEJOIN_ROUND, ft_stroker_process_corner(), ft_stroker_subpath_start(), FT_Vector_From_Polar(), FT_Vector_Length(), TRUE, FT_Vector_::x, and FT_Vector_::y.

Referenced by FT_Stroker_ParseOutline().

FT_Stroker_Done | ( | FT_Stroker | stroker | ) |

Definition at line 858 of file ftstroke.c.

References FT_FREE, ft_stroke_border_done(), and NULL.

FT_Stroker_EndSubPath | ( | FT_Stroker | stroker | ) |

Definition at line 1857 of file ftstroke.c.

References error, FALSE, FT_Angle, FT_Angle_Diff(), FT_ANGLE_PI, FT_Err_Ok, ft_stroke_border_close(), ft_stroker_add_reverse_left(), ft_stroker_cap(), ft_stroker_inside(), FT_Stroker_LineTo(), ft_stroker_outside(), and TRUE.

Referenced by FT_Stroker_ParseOutline().

FT_Stroker_Export | ( | FT_Stroker | stroker,
|  | FT_Outline * | outline
| ) |  |

Definition at line 2029 of file ftstroke.c.

References FT_STROKER_BORDER_LEFT, FT_STROKER_BORDER_RIGHT, and FT_Stroker_ExportBorder().

Referenced by FT_Glyph_Stroke().

FT_Stroker_ExportBorder | ( | FT_Stroker | stroker,
|  | FT_StrokerBorder | border,
|  | FT_Outline * | outline
| ) |  |

Definition at line 2010 of file ftstroke.c.

References ft_stroke_border_export(), FT_STROKER_BORDER_LEFT, and FT_STROKER_BORDER_RIGHT.

Referenced by FT_Glyph_StrokeBorder(), and FT_Stroker_Export().

FT_Stroker_GetBorderCounts | ( | FT_Stroker | stroker,
|  | FT_StrokerBorder | border,
|  | FT_UInt * | anum_points,
|  | FT_UInt * | anum_contours
| ) |  |

Definition at line 1947 of file ftstroke.c.

References error, FT_Err_Invalid_Argument, and ft_stroke_border_get_counts().

Referenced by FT_Glyph_StrokeBorder().

FT_Stroker_GetCounts | ( | FT_Stroker | stroker,
|  | FT_UInt * | anum_points,
|  | FT_UInt * | anum_contours
| ) |  |

Definition at line 1978 of file ftstroke.c.

References error, and ft_stroke_border_get_counts().

Referenced by FT_Glyph_Stroke().

FT_Stroker_LineTo | ( | FT_Stroker | stroker,
|  | FT_Vector * | to
| ) |  |

Definition at line 1280 of file ftstroke.c.

References error, FT_Angle, FT_ANGLE_PI2, FT_Atan2(), FT_Err_Ok, ft_stroke_border_lineto(), ft_stroker_process_corner(), ft_stroker_subpath_start(), FT_Vector_From_Polar(), FT_Vector_Length(), TRUE, FT_Vector_::x, and FT_Vector_::y.

Referenced by FT_Stroker_EndSubPath(), and FT_Stroker_ParseOutline().

FT_Stroker_New | ( | FT_Library | library,
|  | FT_Stroker * | astroker
| ) |  |

Definition at line 789 of file ftstroke.c.

References error, FT_Err_Invalid_Argument, FT_NEW, ft_stroke_border_init(), library, and NULL.

FT_Stroker_ParseOutline | ( | FT_Stroker | stroker,
|  | FT_Outline * | outline,
|  | FT_Bool | opened
| ) |  |

Definition at line 2044 of file ftstroke.c.

References error, FT_CURVE_TAG, FT_CURVE_TAG_CONIC, FT_CURVE_TAG_CUBIC, FT_CURVE_TAG_ON, FT_Err_Invalid_Argument, FT_Err_Invalid_Outline, FT_Err_Ok, FT_Stroker_BeginSubPath(), FT_Stroker_ConicTo(), FT_Stroker_CubicTo(), FT_Stroker_EndSubPath(), FT_Stroker_LineTo(), FT_Stroker_Rewind(), vec, FT_Vector_::x, and FT_Vector_::y.

Referenced by FT_Glyph_Stroke(), and FT_Glyph_StrokeBorder().

FT_Stroker_Rewind | ( | FT_Stroker | stroker | ) |

Definition at line 845 of file ftstroke.c.

References ft_stroke_border_reset().

Referenced by FT_Stroker_ParseOutline(), and FT_Stroker_Set().

FT_Stroker_Set | ( | FT_Stroker | stroker,
|  | FT_Fixed | radius,
|  | FT_Stroker_LineCap | line_cap,
|  | FT_Stroker_LineJoin | line_join,
|  | FT_Fixed | miter_limit
| ) |  |

Definition at line 819 of file ftstroke.c.

References FT_Stroker_Rewind().